/***************************************************************************
                          configdialog.h  -  description
                             -------------------
    begin                : Fri Jun 25 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

class QLineEdit;
class QTable;
class QPushButton;
class QCheckBox;

class KListView;
#include <kdialogbase.h>

class Server;
#include "settings.h"
/**
  *@author David Pye
  */

class ConfigDialog : public KDialogBase  {
	Q_OBJECT
public: 
	ConfigDialog(QWidget *parent);
	~ConfigDialog();

private:
	void parseConfig();
	void exportConfig();
	bool validateSettings();
	void redrawServerList();

	
	//General widget
	QLineEdit *m_tmpPathLineEdit, *m_destPathLineEdit;
	QPushButton *m_tmpPathBrowseBtn, *m_destPathBrowseBtn;

	QCheckBox *m_skipDownloadedFiles, *m_removeCompletedItemsFromQueue, 
		  *m_closeAppWhenComplete, *m_dockToSystray, *m_treePerNzb;
	//Server widget
	QPushButton *m_addServerButton, *m_modifyServerButton, *m_removeServerButton;
	KListView *m_serverListView;
	
	Settings m_settings;
	
private slots:

	virtual void tmpPathBrowseClicked();
	virtual void destPathBrowseClicked();
	
	virtual void slotOk();
	virtual void slotApply();

	virtual void serverSelectionChanged();

	virtual void addServerClicked();
	virtual void modifyServerClicked();
	virtual void deleteServerClicked();

	virtual void addServer(Server*);
	virtual void modifyServer(Server*);
};

#endif
