/***************************************************************************
                   decoder.h  -  Quick and dirty yydecoder class
                             -------------------
    begin                : Sat Jul 3 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DECODER_H
#define DECODER_H

#include <qstring.h>

class QStringList;

/**
  *@author David Pye
  */

class Decoder {

public:
	//QStringList of all the file parts that should be decoded.
	//Output file name is derived from the partfiles, if output filename
	//is null, otherwise it is as specified.
	Decoder(QStringList fileParts, QString outDirectory, QString outFilename=QString::null);
	virtual ~Decoder();

	//Returns the filename the posts specify.
	virtual QString encodedFilename();
	
	//Returns true if this decoder class can decode the parts or not 
	//ie whether they are yyencoded
	virtual bool isDecodable();
	
	//Decodes the next part in the list.	
	//Returns false if an error occurred
	virtual int decodeNextPart();
	
	//Returns true when all the posts are decoded - does not indicate
	//whether all posts were decoded successfully
	virtual bool decodingComplete();

	enum errors {
		ERR_OK,
		ERR_MISSING_PART,
		ERR_CRC,
		ERR_WRITE,
		ERR_NOT_IMPLEMENTED
	};
};
#endif
