/***************************************************************************
                          file.h  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FILE_H
#define FILE_H

#include <qobject.h>
#include <qvaluelist.h>
#include <qstring.h>

class NntpPost;

class File : public QObject {
Q_OBJECT
public: 
	File();
	~File();

	void setPoster(QString);
	void setSubject(QString);
	void setGroup(QString);
	void setfilename(QString);
	void setTotalSegments(int);

	void deletePostFiles(QString dirName, QString prefix);
	QString subject() const;
	QString group() const;

	QString destDir() const;
  	QString filename();
	int totalSegments() const;
	unsigned long sizeKB() const;
	
	bool existsOnDisk(QString dir);
	bool readyToDecode();
	
	void addPost(NntpPost*);
	NntpPost* nextNeededPost();
	QValueList<NntpPost*> posts() const;

	int state();
	void setState(int);
	
	enum {
		QUEUED,
		DOWNLOADING,
		DECODING,
		COMPLETE,
		EXISTS,

		INCOMPLETE,
		DECODE_ERROR
	};
       
	
private:
	QString m_poster, m_subject, m_group;
	QString m_filename;
	QValueList<NntpPost*> m_postList;
	int m_totalSegments;
	unsigned long m_sizeKB;
	bool m_readyToDecode;
	bool m_existsOnDisk;
	int m_state;

private slots:
	void postDeleted();
};

#endif
