/***************************************************************************
                          knzb.h  -  description
                             -------------------
    begin                : Wed Jun 23 23:02:12 BST 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KNZB_H
#define KNZB_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
class QLabel;

class KSystemTray;
#include <kmainwindow.h>
class ConfigDialog;
class NzbParser;
class MainWidget;
class File;

#include "knzbdcopif.h"
#include "settings.h"

class Knzb : public KMainWindow, virtual public KnzbDCOPIf {
	Q_OBJECT 
  	public:
    		Knzb(QWidget* parent=0, const char *name=0);
    		~Knzb();

    	public slots:
		virtual void statusBarMessage(QString);
		virtual void queueSize(double);
	
	private:
    		void checkDirsExist();
		bool queryClose();
	
		bool m_quitApp;
		
		MainWidget *mainWidget;
		KSystemTray *m_systemTray;
		Settings m_settings;
		
		QLabel *m_queueSizeLabel;
		
	private slots:
		virtual void openFileDialog();
		virtual void customize();
		virtual void applySettings();
		virtual void quitApp();
		
		virtual void openFile(const QString&);
    		virtual void startQueue();
		virtual void pauseQueue();
		virtual void emptyQueue();
};

#endif
