/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Wed Jun 23 23:02:12 BST 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <kapplication.h>

#include "knzb.h"

static const char *description =
"Knzb is a KDE client for downloading binary files from Usenet.\nIf handed an nzb file (http://docs.newzbin.com/NZBSpecification), it\nwill download and decode the posts to reconstitute the original files.\nBoth uuEncoded and yEncoded files are supported.\n\nPlease note, the author takes no responsibility for the copyright, or \nlegal status of files downloaded using this software - you\nare responsible for this yourself.\n\nHave fun!";
	
static KCmdLineOptions options[] =
{
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

  KAboutData aboutData( "knzb", I18N_NOOP("Knzb"),
    VERSION, description, KAboutData::License_GPL,
    "(c) 2004-2005, David Pye", 0, 0, "dmp@davidmpye.dyndns.org");
  aboutData.addAuthor("David Pye", "Author", "dmp@davidmpye.dyndns.org", "http://www.dmp.org.uk");
  aboutData.addCredit("Mauro Grauso", "Ideas, suggestions and encouragement", "maurograuso@gmail.com");
  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication a;
  Knzb *knzb = new Knzb();
  a.setMainWidget(knzb);
  knzb->show();  

  return a.exec();
}
