/***************************************************************************
                          nntppost.cpp  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nntppost.h"
#include <qstring.h>
#include <file.h>

NntpPost::NntpPost(QObject *parent, const char *name) : QObject(parent,name) {
	m_parentFile = dynamic_cast<File*>(parent);
	m_state=WAITING;
}

NntpPost::~NntpPost(){
}

void NntpPost::setTitle(QString tmpTitle) {
	m_title = tmpTitle;
}

void NntpPost::setGroup(QString tmpGroup) {
	m_group = tmpGroup;
}

void NntpPost::setBytes(int tmpBytes) {
	m_bytes = tmpBytes;
}

void NntpPost::setSequenceNumber(int tmpsequenceNumber) {
	m_sequenceNumber = tmpsequenceNumber;
}

QString NntpPost::title(){
	return m_title;
}

QString NntpPost::group() {
	return m_group;
}

int NntpPost::bytes() {
	return m_bytes;
}

int NntpPost::sequenceNumber() {
	return m_sequenceNumber;
}

int NntpPost::state() {
	return m_state;
}

void NntpPost::setState(int s) {
	m_state=s;
}

File* const NntpPost::parentFile() {
	return m_parentFile;
}
