/***************************************************************************
                          nntppost.h  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NNTPPOST_H
#define NNTPPOST_H

#include <qstring.h>
#include <qobject.h>
class File;

class NntpPost : public QObject {
Q_OBJECT
public: 
	NntpPost(QObject *parent=NULL, const char *name=NULL);
	~NntpPost();

	void setGroup(QString);
	void setTitle(QString);
	void setBytes(int);
	void setSequenceNumber(int);

	int state();
	void setState(int);
	
	QString title();
	QString group();
	int bytes();
	int sequenceNumber();

	File* const parentFile();

	enum {
		WAITING, //Waiting, not assigned to a server
		QUEUED,  //Assigned to a server, but not yet downloading
		DOWNLOADING, //Downloading
		COMPLETE,    //OK
		FAILED,      //Failed, but not yet given up.
		MISSING      //Given up, can't find this post anywhere.
	};

private:
	QString m_group,m_title;
	int m_bytes, m_sequenceNumber;
	int m_state;
	
	File *m_parentFile;
};

#endif
