/***************************************************************************
                          server.cpp  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "server.h"
#include "nntppost.h"

Server::Server(){

}

Server::~Server(){

}

void Server::setHostName(QString tmphostName) {
	m_hostName = tmphostName;
}

void Server::setDisplayName(QString tmpdisplayName) {
	m_displayName = tmpdisplayName;
}

void Server::setMaxThreads(int tmpmaxThreads) {
	m_maxThreads = tmpmaxThreads;
	m_availableThreads = m_maxThreads;
}

void Server::setTimeout(int tmptimeout) {
	m_timeout = tmptimeout;
}

void Server::setPriority(int tmppriority) {
	m_priority = tmppriority;
}

void Server::setPort(int tmpport) {
	m_port = tmpport;
}

const QString Server::hostName() const{
	return m_hostName;
}

QString Server::displayName() const {
	return m_displayName;
}

const int Server::maxThreads() const {
	return m_maxThreads;
}

const int Server::priority() const {
	return m_priority;
}

const int Server::timeout() const {
	return m_timeout;
}

const int Server::port() const {
	return m_port;
}

const bool Server::authRequired() const {
	return m_authRequired;
}

void Server::setAuthRequired(bool auth) {
	m_authRequired = auth;
}

const QString Server::password() const{
	return m_password;
}

const QString Server::username() const {
	return m_username;
}

void Server::setUsername(QString tmpusername) {
	m_username = tmpusername;
}

void Server::setPassword(QString tmppassword) {
	m_password = tmppassword;
}

int Server::availableThreads() {
	return m_availableThreads;
}

void Server::decrementAvailableThreads() {
	if (m_availableThreads>0) m_availableThreads--;
}

void Server::incrementAvailableThreads() {
	m_availableThreads++;
}

bool Server::enabled() {
	return m_enabled;
}

void Server::setEnabled(bool b) {
	m_enabled=b;
}

void Server::queuePost(NntpPost *p) {
	connect(p, SIGNAL(destroyed()), this, SLOT(postDeleted()));
	m_postQueue.append(p);
}

NntpPost* Server::nextQueuedPost() {
	NntpPost *p = NULL;
	if (! m_postQueue.isEmpty()) {
		p = m_postQueue.first();
		m_postQueue.remove(m_postQueue.first());
	}
	return p;
}

void Server::postDeleted() {
        const NntpPost *p = dynamic_cast<const NntpPost*>(QObject::sender());
        if (p) m_postQueue.remove((NntpPost*)p);
}

