/***************************************************************************
                          server.h  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SERVER_H
#define SERVER_H

#include <qobject.h>

class NntpPost;
/**
  *@author David Pye
  */

class Server : public QObject  {
Q_OBJECT
public: 
	Server();
	~Server();

	void setDisplayName(QString);
	void setHostName(QString);
	void setPriority(int);
	void setMaxThreads(int);
	void setTimeout(int);
	void setPort(int);
	void setAuthRequired(bool);
	void setUsername(QString);
	void setPassword(QString);

	QString displayName() const;
	const QString hostName() const;
	const QString username() const;
	const QString password() const;
	const bool authRequired() const;
	const int port() const;
	const int priority() const;
	const int maxThreads() const;
	const int timeout() const;

	int availableThreads();
	void incrementAvailableThreads();
	void decrementAvailableThreads();

	bool enabled();
	void setEnabled(bool);

	void queuePost(NntpPost*);
	NntpPost *nextQueuedPost();

private:
	QValueList<NntpPost*> m_postQueue;

	QString m_displayName, m_hostName;
  	QString m_username, m_password;
	int m_priority, m_maxThreads, m_availableThreads, m_timeout, m_port;
	bool m_authRequired;
	bool m_enabled;

private slots:
	void postDeleted();
};

#endif
