/***************************************************************************
                          servermanager.h  -  description
                             -------------------
    begin                : Thu Jun 24 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SERVERMANAGER_H
#define SERVERMANAGER_H

#include <qobject.h>
#include <qvaluelist.h>
#include <qmap.h>

class Server;
class NntpPost;
#include "settings.h"
/**
  *@author David Pye
  */

class ServerManager : public QObject {
	Q_OBJECT
	
public: 
	ServerManager();
	~ServerManager();
	void applySettings(Settings*);

	Server* getNextServer(Server*);

	Server* getNextServerForPost(NntpPost*, Server *s);
	//You should call this once a post completes successfully to
	//prevent the table of which servers have it from 
	void removeRecord(NntpPost*);
	
private:
	QValueList<Server*> m_serverList;
	        
	//This QMap maps each post to a record of which
	//servers have been tried so far to find it.
	QMap<const NntpPost*, QValueList<Server*> > m_serversTriedMap;

private slots:
	void postDeleted();

};
#endif
