/***************************************************************************
                          serversettingsdialog.h  -  description
                             -------------------
    begin                : Wed Jul 7 2004
    copyright            : (C) 2004 by David Pye
    email                : dmp@davidmpye.dyndns.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SERVERSETTINGSDIALOG_H
#define SERVERSETTINGSDIALOG_H

class QLineEdit;
class QCheckBox;
class QSpinBox;

class Server;

#include <kdialogbase.h>



/**
  *@author David Pye
  */

class ServerSettingsDialog : public KDialogBase  {
	Q_OBJECT
public:
	ServerSettingsDialog(QWidget *parent=0l, const char* name=0l );
	~ServerSettingsDialog();

	void modifyServerSettings(Server*);

signals:
	void serverDetails(Server*);

private:
	QLineEdit *m_displayName, *m_hostname, *m_portNo;
	QCheckBox *m_enabled;
	
	QLineEdit *m_username, *m_password;
	QCheckBox *m_authRequired;
	QSpinBox *m_priority, *m_maxConnections, *m_timeout;
  
	bool checkValid();
	
	private slots:
	virtual void slotOk();
	virtual void authRequiredToggled(bool);
};

#endif
